/**************************************************************************/
/*                                                                        */
/* Copyright (c) 2001, 2024 NoMachine, http://www.nomachine.com/.         */
/*                                                                        */
/* NXEXEC, NX protocol compression and NX extensions to this software     */
/* are copyright of NoMachine. Redistribution and use of the present      */
/* software is allowed according to terms specified in the file LICENSE   */
/* which comes in the source distribution.                                */
/*                                                                        */
/* Check http://www.nomachine.com/licensing.html for applicability.       */
/*                                                                        */
/* NX and NoMachine are trademarks of NoMachine S.a.r.l.                  */
/*                                                                        */
/* All rights reserved.                                                   */
/*                                                                        */
/**************************************************************************/

#ifndef _TokenClient_h_
#define _TokenClient_h_

#include <stdio.h>
#include <windows.h>

const char *tokenMessageBegin = "TOKEN_MESSAGE_BEGIN";
const char *tokenMessageEnd   = "TOKEN_MESSAGE_END";

#define StringSafeCatLen(destination, source, len) { destination[len - 1] = 0; int lenn = len - strlen((destination)); strncat((destination), (source), lenn - 1);}

#define StringSafeCopyLen(destination, source, len) destination[len - 1] = 0; strncpy((destination), (source), len - 1);

static const int maxs = 4000;

typedef struct TokenMessage
{
  char sid[4000];
  char clientPipe[4000];
  char serverAr[4000];
  char sshConnection[4000];
  char nxConnection[4000];
  char krb5ccname[4000];

  int setToken;
  int getToken;

  int execServer;
  
  long long int in;
  long long int out;
  long long int err;
  long long int process;

  int pid;
  int result;

  int complete;
} TokenMessage;

typedef enum
{
  BeginMessage,
  Message,
  EndMessage,
  
  MessageComponents

} TokenMessageOrder;

#endif
